- Aldebaran documentation |
- C++ Libraries |
- index

libqi-api 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | List of all members
qi::ObjectTypeBuilderBase Class Reference

`#include <objecttypebuilder.hpp>`

## Public Types
using | SignalMemberGetter = boost::function< SignalBase *(void *)>
using | PropertyMemberGetter = boost::function< PropertyBase *(void *)>

## Public Member Functions
| ObjectTypeBuilderBase ()
| ~ObjectTypeBuilderBase ()
void | setDescription (const std::string &description)
| Sets a description for the type to build. More...
template<typename T >
void | buildFor (bool autoRegister=true)
| Declare the class type for which this StaticBuilder is. More...
template<typename FUNCTION_TYPE >
unsigned int | advertiseMethod (const std::string &name, FUNCTION_TYPE function, MetaCallType threadingModel=MetaCallType_Auto, int id=-1)
template<typename FUNCTION_TYPE >
unsigned int | advertiseMethod (MetaMethodBuilder &name, FUNCTION_TYPE function, MetaCallType threadingModel=MetaCallType_Auto, int id=-1)
template<typename A >
unsigned int | advertiseSignal (const std::string &eventName, A accessor, int id=-1, bool isSignalProperty=false)
template<typename T >
unsigned int | advertiseSignal (const std::string &name, SignalMemberGetter getter, int id=-1, bool isSignalProperty=false)
template<typename A >
unsigned int | advertiseProperty (const std::string &propertyName, A accessor)
template<typename T >
unsigned int | advertiseProperty (const std::string &eventName, PropertyMemberGetter getter)
template<typename T , typename... Args>
unsigned int | advertiseFactory (const std::string &name)
template<typename P >
void | inherits (std::ptrdiff_t offset)
template<typename T >
ObjectTypeBuilderBase & | advertise (const std::string &name, T element)
template<typename T >
unsigned int | advertiseId (const std::string &name, T element)
unsigned int | xAdvertiseMethod (MetaMethodBuilder &builder, AnyFunction func, MetaCallType threadingModel=MetaCallType_Auto, int id=-1)
unsigned int | xAdvertiseSignal (const std::string &name, const qi::Signature &signature, SignalMemberGetter getter, int id=-1, bool isSignalProperty=false)
unsigned int | xAdvertiseProperty (const std::string &name, const qi::Signature &signature, PropertyMemberGetter getter, int id=-1)
void | xBuildFor (TypeInterface *type, bool autoRegister, qi::AnyFunction strandAccessor)
void | inherits (TypeInterface *parentType, std::ptrdiff_t offset)
void | setThreadingModel (ObjectThreadingModel model)
const MetaObject & | metaObject ()
AnyObject | object (void *ptr, boost::function< void(GenericObject *)> onDestroy=boost::function< void(GenericObject *)>())
ObjectTypeInterface * | type ()
virtual void | registerType ()
| Register type to typeof. Called by type() More...
const detail::ObjectTypeData & | typeData ()

## Detailed Description

Definition at line 36 of file objecttypebuilder.hpp.

## Member Typedef Documentation

using qi::ObjectTypeBuilderBase::PropertyMemberGetter = boost::function<PropertyBase* (void*)>

Definition at line 43 of file objecttypebuilder.hpp.

using qi::ObjectTypeBuilderBase::SignalMemberGetter = boost::function<SignalBase* (void*)>

Definition at line 42 of file objecttypebuilder.hpp.

## Constructor & Destructor Documentation

qi::ObjectTypeBuilderBase::ObjectTypeBuilderBase | ( |  | ) |

qi::ObjectTypeBuilderBase::~ObjectTypeBuilderBase | ( |  | ) |

## Member Function Documentation

template<typename T >

ObjectTypeBuilderBase & qi::ObjectTypeBuilderBase::advertise | ( | const std::string & | name,
|  | T | element
| ) |  |

Definition at line 277 of file objecttypebuilder.hxx.

template<typename T , typename... Args>

unsigned int qi::ObjectTypeBuilderBase::advertiseFactory | ( | const std::string & | name | ) |
| inline

create a T, wrap in a AnyObject All template parameters are given to the T constructor except the first one

Definition at line 75 of file objecttypebuilder.hpp.

template<typename T >

unsigned int qi::ObjectTypeBuilderBase::advertiseId | ( | const std::string & | name,
|  | T | element
| ) |  |

Definition at line 271 of file objecttypebuilder.hxx.

template<typename FUNCTION_TYPE >

unsigned int qi::ObjectTypeBuilderBase::advertiseMethod | ( | const std::string & | name,
|  | FUNCTION_TYPE | function,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`,
|  | int | id = `-1`
| ) |  |
| inline

Definition at line 57 of file objecttypebuilder.hxx.

template<typename FUNCTION_TYPE >

unsigned int qi::ObjectTypeBuilderBase::advertiseMethod | ( | MetaMethodBuilder & | name,
|  | FUNCTION_TYPE | function,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`,
|  | int | id = `-1`
| ) |  |
| inline

Definition at line 72 of file objecttypebuilder.hxx.

template<typename A >

unsigned int qi::ObjectTypeBuilderBase::advertiseProperty | ( | const std::string & | propertyName,
|  | A | accessor
| ) |  |
| inline

Definition at line 189 of file objecttypebuilder.hxx.

template<typename T >

unsigned int qi::ObjectTypeBuilderBase::advertiseProperty | ( | const std::string & | eventName,
|  | PropertyMemberGetter | getter
| ) |  |
| inline

Definition at line 203 of file objecttypebuilder.hxx.

template<typename A >

unsigned int qi::ObjectTypeBuilderBase::advertiseSignal | ( | const std::string & | eventName,
|  | A | accessor,
|  | int | id = `-1`,
|  | bool | isSignalProperty = `false`
| ) |  |

Definition at line 180 of file objecttypebuilder.hxx.

template<typename T >

unsigned int qi::ObjectTypeBuilderBase::advertiseSignal | ( | const std::string & | name,
|  | SignalMemberGetter | getter,
|  | int | id = `-1`,
|  | bool | isSignalProperty = `false`
| ) |  |
| inline

Definition at line 197 of file objecttypebuilder.hxx.

template<typename T >

void qi::ObjectTypeBuilderBase::buildFor | ( | bool | autoRegister = `true` | ) |

Declare the class type for which this StaticBuilder is.

Definition at line 40 of file objecttypebuilder.hxx.

template<typename U >

void qi::ObjectTypeBuilderBase::inherits | ( | std::ptrdiff_t | offset | ) |

Definition at line 85 of file objecttypebuilder.hxx.

void qi::ObjectTypeBuilderBase::inherits | ( | TypeInterface * | parentType,
|  | std::ptrdiff_t | offset
| ) |  |

const MetaObject& qi::ObjectTypeBuilderBase::metaObject | ( |  | ) |

AnyObject qi::ObjectTypeBuilderBase::object | ( | void * | ptr,
|  | boost::function< void(GenericObject *)> | onDestroy = `boost::function< void(GenericObject *)>()`
| ) |  |

virtual void qi::ObjectTypeBuilderBase::registerType | ( |  | ) |
| inline virtual

Register type to typeof. Called by type()

Reimplemented in qi::ObjectTypeBuilder< T >.

Definition at line 107 of file objecttypebuilder.hpp.

void qi::ObjectTypeBuilderBase::setDescription | ( | const std::string & | description | ) |

Sets a description for the type to build.

void qi::ObjectTypeBuilderBase::setThreadingModel | ( | ObjectThreadingModel | model | ) |

ObjectTypeInterface* qi::ObjectTypeBuilderBase::type | ( |  | ) |

const detail::ObjectTypeData& qi::ObjectTypeBuilderBase::typeData | ( |  | ) |

unsigned int qi::ObjectTypeBuilderBase::xAdvertiseMethod | ( | MetaMethodBuilder & | builder,
|  | AnyFunction | func,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`,
|  | int | id = `-1`
| ) |  |

unsigned int qi::ObjectTypeBuilderBase::xAdvertiseProperty | ( | const std::string & | name,
|  | const qi::Signature & | signature,
|  | PropertyMemberGetter | getter,
|  | int | id = `-1`
| ) |  |

unsigned int qi::ObjectTypeBuilderBase::xAdvertiseSignal | ( | const std::string & | name,
|  | const qi::Signature & | signature,
|  | SignalMemberGetter | getter,
|  | int | id = `-1`,
|  | bool | isSignalProperty = `false`
| ) |  |

void qi::ObjectTypeBuilderBase::xBuildFor | ( | TypeInterface * | type,
|  | bool | autoRegister,
|  | qi::AnyFunction | strandAccessor
| ) |  |

The documentation for this class was generated from the following files:

- /home/opennao/work/release-2.8/sdk/libqi/qi/type/objecttypebuilder.hpp
- /home/opennao/work/release-2.8/sdk/libqi/qi/type/detail/objecttypebuilder.hxx